#INCLUDE "dcdialog.CH"
#INCLUDE "gra.CH"
#INCLUDE "appevent.CH"
#INCLUDE "dcuser.CH"
#include "dcxbrow.ch"

#include "cdxdbe.ch"
#include "dbfdbe.ch"
#include "foxdbe.ch"

*toto potrebn pre ACE
#INCLUDE "ACE_UDF.CH"
#INCLUDE "ACE.CH"

#INCLUDE "XBP.CH"
#include "dll.ch"
#include "common.ch"
#include "font.ch"

#INCLUDE "SQL.CH"
#INCLUDE "SQLEXT.CH"
#INCLUDE "INKEY.CH"

***************
FUNCTION Main
***************
LOCAL GetList := {}, oBrowse, aFields[3], aHeaders[3], aPres
LOCAL GetOptions, oToolBar, oDlg
LOCAL wslist
LOCAL cAlias1 := "VLASTNICI"

afields[1]:=cAlias1+"->NPK"
afields[2]:=cAlias1+"->PCS"
afields[3]:=cAlias1+"->VLA"
aheaders[1]:="NPK"
aheaders[2]:="PCS"
aheaders[3]:="VLA"
Set Deleted On

*AceSetTableType("DBFCDX")   // set the default table type to be ADS_CDX
AceSetTableType("FOXCDX")   // set the default table type to be ADS_CDX

SET FIXED ON
SET DECIMALS TO 0

SET CHARSET TO OEM
*SET CHARSET TO ANSI

SET DATE GERMAN
*SET COLLATION TO GERMAN
SET COLLATION TO SYSTEM

*******************************************************************
* OTVORENIE DATABZY - PRAVIDL PRE ACEWRAPPERS
*******************************************************************

* Open database
*SELECT 1	// disabled, works only with DBF/CDX 
use PK800490 ALIAS (cAlias1) NEW EXCLUSIVE

if used()
	*DC_msgbox("USE bez indexu Ok")
else
	*DC_msgbox("USE bez indexusa nepodaril")
endif
*DC_msgbox("select "+str(select()))
*DC_msgbox("alias "+alias())

if used()
	*DC_Msgbox("used ok, idem indexova")
        INDEX ON NPK TAG NPK
	*DC_msgbox("select po indexcii "+str(select()))
	*DC_msgbox("alias po indexcii "+alias())
	*close cAlias1
	DbCloseAll()	
	*DC_msgbox("select po close calias "+str(select()))
	*DC_msgbox("alias po close calias "+alias())
endif
*DC_msgbox("po indexcii, idem znova otvori u s indexom")

use PK800490 ALIAS (cAlias1) 

DC_msgbox("select po use s indexom "+str(select()))
DC_msgbox("alias po use s indexom  "+alias())
if used()
	DC_msgbox("USE s INDEX Ok")
else
	DC_msgbox("USE s INDEX sa nepodaril")
endif

* tested several methods, 
*SELECT 1        
*SELECT cAlias1
*SELECT (cAlias1)
*SELECT 'VLASTNICI'
*SELECT ('VLASTNICI')
*dbselectarea(cAlias1)

*DC_msgbox("select po dbselectarea "+str(select()))
*DC_msgbox("alias po dbselectarea "+alias())

*set order to 1
*go top

* also here alias is not empty
*
if empty(select(cAlias1))
dc_msgbox("select calias je empty")
else
dc_msgbox("select calias NIEJE empty")
endif
*

* Here show content of fields from table, ok, works
**********************************************
Dc_msgbox(VLASTNICI->NPK)                // ok

*Dc_msgbox((cAlias1)->NPK)                // ok
*Dc_msgbox(cAlias1->NPK)                // error !
*Dc_msgbox(Fieldwget(cAlias1,"NPK"))        // ok
*Dc_msgbox(Fieldget(Fieldpos("NPK")))        // ok

*Dc_msgbox(str(select()))
*Dc_msgbox(alias())

*(calias1)->(DbGoTop())
*Dc_msgbox((cAlias1)->NPK)                // ok
(calias1)->(DbGoBottom())
Dc_msgbox((cAlias1)->NPK)                // ok

*bNPK:={||(cAlias1->NPK)}
*

* I tryed also this, but this not work, workspacelist is always blank !
*DC_msgbox("idem na DbRequest calias")
*lako:=DbRequest(cAlias1)
*DC_msgbox("lako po DbRequest "+ltoc(lako))
*DC_msgbox("idem vypsa workspacelist")

*wslist:=workspacelist()

*DC_msgbox("len wslist="+str(len(wslist)))
*DC_msgbox("obsah prvok 1 :"+wslist[1])
*DbRequest(cAlias1)
*DC_msgbox(workspacelist())


* Here error DAC 8500, no more room to create workspace

/*
*********************************
* ZOBRAZENIE CEZ DCQUICKBROWSE
*********************************
*@ 1,1 DCQUICKBROWSE ALIAS 'VLASTNICI' SIZE 150,20 ;	// pri klasik berie toto
*@ 1,1 DCQUICKBROWSE ALIAS "VLASTNICI" SIZE 150,20 ;	// aj toto
@ 1,1 DCQUICKBROWSE ALIAS (cAlias1) SIZE 150,20 ;	// aj toto
   OBJECT oBrowse ;
   FIELDS aFields HEADERS aHeaders ;
   STYLE XBP_STYLE_FANCY ;
   CURSORMODE XBPBRW_CURSOR_CELL

DCREAD GUI FIT ADDBUTTONS ;
   TITLE 'Quick-Browsing a Database'
*/

*
**************************************
* ZOBRAZENIE CEZ DCBROWSE
**************************************
*@ 1,1 DCBROWSE oBrowse ALIAS "VLASTNICI" SIZE 150,20 
*@ 1,1 DCBROWSE oBrowse ALIAS 'VLASTNICI' SIZE 150,20 ;
@ 1,1 DCBROWSE oBrowse ALIAS cAlias1 SIZE 150,20 ;	// toto klasik berie
           NOSOFTTRACK ;
	   SCOPE ;	
           OPTIMIZE ;
           CURSORMODE XBPBRW_CURSOR_ROW  

*************************************
* Here error XBT0231 Invalid lvalue
*************************************

*DCBROWSECOL FIELD VLASTNICI->NPK ;	// toto klasik berie
*  HEADER "NPK" PARENT oBrowse		// parent dleit !!!

*********************************************************
* Here error BASE/8022 Unknown/invalid symbol for alias
*********************************************************

DCBROWSECOL FIELD cAlias1->NPK ;	// toto klasik berie
  HEADER "NPK" PARENT oBrowse		// parent dleit !!!


* Also tryed this, but no work ...

*DCBROWSECOL DATA DC_FieldWBlock("NPK",cAlias1) ;

*DCBROWSECOL DATA {||FIELD->NPK}

*DCBROWSECOL DATA DC_FieldWBlock("NPK",cAlias1) ;

*DCBROWSECOL DATA {||(Fieldget(FieldPos("NPK")))}

*DCBROWSECOL DATA (Fieldwget((cAlias1),"NPK"))

DCREAD GUI FIT ADDBUTTONS  ;
   TITLE 'Quick-Browsing a Database' 

*

close all

RETURN nil


PROC appsys
RETURN


****************************
PROCEDURE DbeSys()
****************************
_LoadDbes()

RETURN

****************************************
STATIC FUNCTION _LoadDbes()
****************************************
LOCAL i, aDbeList := DbeList(), cDbeList := ''

*qqq 4.5.2016 znova pokusym dopam a testujem toto, ale nem to vplyv na triedenie VL

* !!! POZOR !!! , ak je SET COLLATION TO SYSTEM tak to ma veky vplyv na porovnavanie reazcov v celom programe !!!
* vtedy je porovnavanie =<>... case insensitive
* preto musm poui SET COLLATION TO GERMAN, alebo in

*SET COLLATION TO SYSTEM	// NEDVA !!!

SET COLLATION TO GERMAN	// v CDX sa objav text GERMAN				// TOTO SKڊAM kvli RLC5D kdovaniu a porovnvaniu reazcov
										// lebo ak je SYSTEM,tak je porovnanie case insensitive

*SET COLLATION TO ASCII		// v CDX sa neobjav iadny text, teda ani SWEFIN
*SET COLLATION TO AMERICAN	
* ak nedm ni			// v CDX sa objav GENERAL

*qqq 4.5.2016 aj toto dvam poda PRAHA, ale nem vplyv na triedenie

*qqq 13.10.2016 skam aktvne poda rady Bielik test indexov ale asi to nem vplyv na ni
*Set Optimize Off
*Set Rushmore Off
*Set SmartFilter Off

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

  IF !('DBFDBE'$aDbeList) .AND. !DbeLoad( "DBFDBE",.T.)
     DC_WinAlert( "Database-Engine DBFDBE not loaded" )
  ENDIF
  IF !('NTXDBE'$aDbeList) .AND. !DbeLoad( "NTXDBE",.T.)
     DC_WinAlert( "Database-Engine NTXDBE not loaded"  )
  ENDIF
  IF !('DBFNTX'$aDbeList) .AND. !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
     DC_WinAlert( "DBFNTX Database-Engine, Could not build engine" )
  ENDIF
  IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
     DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  ENDIF
  IF !('DBFCDX'$aDbeList) .AND. !DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
     DC_WinAlert( "DBFCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
     DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  ENDIF
  IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
     DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('DELDBE'$aDbeList) .AND. !DbeLoad( "DELDBE",.T.)
     DC_WinAlert( "Database-Engine DELDBE not loaded" )
  ENDIF

DbeSetDefault( "FOXCDX" )	// toto bolo
*DbeSetDefault( "DBFCDX" )	// toto iba som skal, ale bez rozdielu

*qqq 4.5.2016 toto skam preddefinova u tu, hoci vetko preindexujem, ale nem vplyv
* ale vetko blokujem, lebo som nezistil eby to malo na dao vplyv

* toto mm z cdxdbe.ch
*DbeInfo(COMPONENT_ORDER,CDXDBE_MODE,CDXDBE_VFOXPRO)							
*DbeInfo(COMPONENT_ORDER,CDXDBE_MODE,CDXDBE_FOXPRO2X)	// toto zhavaruje, lebo index je VFP

*DBEINFO(COMPONENT_DATA,FOXDBE_CREATE_2X,TRUE)

* toto mm z foxdbe.ch
*DBEINFO(COMPONENT_DATA,FOXDBE_LOCKMODE,FOXDBE_LOCKMODE_AUTO)						
*DBEINFO(COMPONENT_DATA,FOXDBE_LOCKMODE,FOXDBE_LOCKMODE_2X)
*DBEINFO(COMPONENT_DATA,FOXDBE_LOCKMODE,FOXDBE_LOCKMODE_VISUAL)
*DBEINFO(COMPONENT_DATA,FOXDBE_LOCKMODE,FOXDBE_CLIPPER)

* neviem nao to je, blokujem, je to z fora niektor prspevok
*DBEINFO( COMPONENT_DATA, FOXDBE_LOCKRETRY, 100000 )
*DBEINFO( COMPONENT_ORDER, CDXDBE_LOCKRETRY, 100000 )	

*qqq 13.10.2016 doplnen poda rady Bielik
*DbeInfo(COMPONENT_DATA,  FOXDBE_LIFETIME,       0  )    && bielik						
DbeInfo(COMPONENT_DATA,  FOXDBE_LIFETIME,       20 )    && bielik						

*qqq implementcia funkcie od Janka, tto iba napln collation tabuku a predvol COLLAT_USER
* ale problm kompatibility z SLOVAK CDX z WISKN pretrvva 
*Ritrajv()
*SetColl()

*SetSystemCollation()	// toto skam, z internetu zdroj ale je to len asi in verzia ako upravi collation

RETURN .t.

FUNCTION SQLExpressKey(); Return nil   // <-- put your SQLExpress license key here